

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

/*
Quarz, BrownOut 4.0V, WatchDog, CKOPT, 8 MHZ
Low Fuse=0x7F   High Fuse= 0x89

TIMER 0 = TICK
TIMER 1 = 16 BIt PWM_T1
TIMER 2 = PWM

Processor 1 = links
#define UART_BAUD_RATE 9600

USBasp auf libusb-win32 driver mit Zadig einstellen, NICH!! WIN32

http://www.engbedded.com/fusecalc/
*/
//#define  TICK_USED
//#define UART_IS_USED

//alternate  Low Fuse=0x9E   High Fuse= 0xEF
#define SOFTWARE "Software: ATM8-MinBoard_IO"
#define AUTOR		"Christof Ermer"
#define DATUM		"03.12.2020"
#define HARDWARE	"AT8 8MHz MiniBoard-IO"
#define SHOW_BAUDRATE	"9600,8,N,1"

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr/interrupt.h>  // obsolete #include <avr\signal.h>

#include <avr/wdt.h>
//Produziert Fehler...
#include <util/delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "main.h"		//witdh Hardware assigns
#include "uart328.h"
#include "TxtFunc.h"
#include "debug.h"



//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };

volatile uint32_t gu32_Ticks; //T2 timeCounter, only NN_Counter for Keypressings
//uint8_t gu8Mode;
volatile uint8_t gu8Status;
volatile uint16_t gu16TCNT1;
volatile float gufT1_MeasureFRQ;

//proto
void READ_FRQ_Start( void );  //Frequenz MESSEN  MIT TICK TIME


//TCKcounter
// ****************************************
ISR( TIMER0_OVF_vect )	//ATMEGA8
// ****************************************
{
gu32_Ticks++;
if( !(gu32_Ticks % TICK_1000MS) )
	{
	if( gu8Status & FRQ_MEASURE_ACTIVE_FLAG ) // FequnqzMessung
		{
		TCCR1B = 0; //STOP T1
		gu16TCNT1 = TCNT1; // Hohle wert = Pulse/sec
		TCCR1A = 0;
		TCNT1=0;
		DDRD &= ~(1<< PD5);  // T1
		PORTD &= ~(1<< PD5);  // T1
		gufT1_MeasureFRQ = gu16TCNT1;  //* FRQ_FLOAT_FAKTOR;(1000.0/TICKTIME_FLOAT )	
		gu8Status &= ~FRQ_MEASURE_ACTIVE_FLAG;
		gu8Status |= FRQ_MEASURE_READY_FLAG;
		};
	gu8Status |= TICK_EVENT;
	}; // Tickcounter

if( gu32_Ticks & 0b111 )	//(2^n-1) binr jeder 2.te
	{
	UART_TXRX_Check();	//IMMER VORHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
	}; // Tickcounter
};


// ************OVL*************************
void Start_TICK_T0(void)		//ATMEGA8//244 INT/Sec
// *************************************
{
// 8*10^6  / 256 / 256 = 122.0703125  pro sekunde
cli();
TCNT0= 0;
TIFR = (1 << TOV0);  //OVL
TIMSK |= (1 << TOIE0);  //OVL
TCCR0 = (1 << CS01);  //Scale 8//  = 31250
sei();
};


// ********************************************
//ATMEGA8 // MIT CTC MODUS
void SelectBestPreScaler_T1( uint32_t uxSollFrq ) // 32 BIT  MIT CTC MODUS
// ********************************************
{
uxSollFrq*= 2;   // Toogle = / 2
if( (F_CPU / 1.0 / uxSollFrq ) > 0xFFFF)
	{
	if( (F_CPU / 8.0 / uxSollFrq ) > 0xFFFF) 
		{
		if( (F_CPU / 64.0 / uxSollFrq ) > 0xFFFF) 
			{
			if( (F_CPU / 256.0 / uxSollFrq )  > 0xFFFF) 
				{
				OCR1A =  round(F_CPU / 1024 / uxSollFrq);
				TCCR1B = (1<< WGM12) | (1<<CS12) | (1<< CS10); //CTC 1024
				}
			else
				{				
				OCR1A =  round(F_CPU / 256 / uxSollFrq);
				TCCR1B = (1<< WGM12) | (1<<CS12); //CTC 256
				};
			}
		else
			{
			OCR1A =  round(F_CPU / 64 / uxSollFrq);
			TCCR1B = (1<< WGM12) | (1<<CS11) | (1<<CS10); //CTC 64
			};
		}
	else	
		{	
		OCR1A =  round(F_CPU / 8 / uxSollFrq);
		TCCR1B = (1<< WGM12) | (1<<CS11); //CTC 8
		};			
	}
else
	{
	OCR1A =  round(F_CPU / uxSollFrq); // /1
	TCCR1B = (1<< WGM12) | (1<<CS10); //CTC 1
	}; 
};



// ***********************************
void T1_INITPIN_STOP_CTC(void )  //nix Frequenz
// ***********************************
{
TCCR1A = 0;
TCCR1B = 0;
TCNT1 = 0;
INIT_OC1A_PIN();  
CLR_T1_OC1A_PIN();
};


// ***********************************
void T1_CTC( uint32_t uxSollFrq )  //ACHT ng 32 BIT Frequenz Ausgeben
//ATMEGA8
// ***********************************
{
T1_INITPIN_STOP_CTC();
if( uxSollFrq < 1 ) return;
TCCR1A = (1<< COM1A0);  // Toogle OC1A
//OCRx =  Quarz / Vorteiler / gewnschte Frequenz
SelectBestPreScaler_T1( uxSollFrq ); //TCCR1B = (1<< WGM12) + CSx; //CTC
};



// ***********************************
// FAST PWM 10 BIT 1024
void T1_PWM( uint16_t uxPWM )  //30 HERZ !! T1 16Bit PWM
//ATMEGA8
// ***********************************
{
T1_INITPIN_STOP_CTC();
if( (uxPWM < 1) || (uxPWM > 1023) ) return;
INIT_OC1A_PIN();  
//FAst PWM 10 BIT
OCR1A = uxPWM;  
TCCR1A = (1<< COM1A1) | (1<< WGM11) | (1<< WGM10);  // CLEAR OC1A on MATCH
TCCR1B = (1<< WGM12) | T1_CS_256;  // Vorbesetzen
};


// ***********************************
// FAST PWM 10 BIT 1024
void T1_FRQPWM( uint16_t uxFrq, uint16_t uxPWM )  //T1 16Bit PWM
//ATMEGA8
// ***********************************
{
T1_INITPIN_STOP_CTC();
if( (uxPWM  < 1) || (uxPWM > 1023) ) return;
//FAst PWM 10 BIT
OCR1A = uxPWM;  
TCCR1A = (1<< COM1A1) | (1<< WGM11) | (1<< WGM10);  // CLEAR OC1A on MATCH
TCCR1B = (1<< WGM12);  // Vorbesetzen
if(uxFrq == 7812){ TCCR1B |= T1_CS_1; return; };
if(uxFrq == 977){ TCCR1B |= T1_CS_8; return; };
if(uxFrq == 122){ TCCR1B |= T1_CS_64; return; };
if(uxFrq == 30){ TCCR1B |= T1_CS_256; return; };
if(uxFrq == 8){ TCCR1B |= T1_CS_1024; return; };
T1_INITPIN_STOP_CTC(); // Keine Auswahl
//OCRx =  Quarz / Vorteiler / gewnschte Frequenz
};





// ***********************************
// ATMEGA 8
void READ_FRQ_Start( void )  //Frequenz MESSEN  MIT TICK TIME
//ATMEGA8
// ***********************************
{ //ClockSOurce =  T1
TCCR1B = 0;
DDRD &= ~(1<< PD5);  // T1
PORTD &= ~(1<< PD5); // T1 Pullup off
OCR1A = 0xFF;
OCR1B = 0xFF;
TCCR1A = 0;
TCNT1 = 0;
cli();
gu32_Ticks = 0; // Stelle 1 Sec Time auf 0
gu8Status |= FRQ_MEASURE_ACTIVE_FLAG;
TCCR1B = (1<< CS12) | (1<< CS11); //T1 SOURCE Falling Edge  
sei();
};



// ***********************************
void READ_FRQ_Stop( void )  //Frequenz MESSEN  MIT TICK TIME
//ATMEGA8
// ***********************************
{ //ClockSOurce =  T1
gu8Status &= ~FRQ_MEASURE_ACTIVE_FLAG;
DDRD &= ~(1<< PD5);  // T1
PORTD &= ~(1<< PD5); // T1
TCCR1B = 0;
TCCR1A = 0;
TCNT1 = 0;
};


// ********************************************
//ATMEGA8  PWM BASE FREQUENZ UND PWM 0..255
void SelectBestPreScaler_T2( uint16_t u16Frq, uint8_t u8PWM ) //FastPWM CLR OC2
// OHNE WGMxx MODUS
// ********************************************
{
TCCR2 = 0;
TCNT2 = 0;
if( (F_CPU / 1.0 / u16Frq) > 0xFF )
	{
	if( (F_CPU / 8.0 / u16Frq) > 0xFF ) 
		{
		if( (F_CPU /32.0 / u16Frq ) > 0xFF ) 
			{
			if( (F_CPU / 64.0 / u16Frq ) > 0xFF ) 
				{
				if( (F_CPU / 128.0 / u16Frq ) > 0xFF) 
					{
					if( (F_CPU / 256.0 / u16Frq )  > 0xFF) 
						{
						OCR2 =  round(F_CPU / 1024 / u16Frq);
						TCCR2 = (1<<CS22) | (1<<COM21) | (1<< CS20); //CTC 1024
						}
					else
						{				
						OCR2 =  round(F_CPU / 256 / u8PWM);
						TCCR2 = (1<<CS22) | (1<<CS21); //CTC 256
						};
					}
				else
					{				
					OCR2 =  round(F_CPU / 128 / u8PWM);
					TCCR2 = (1<<CS22) | (1<<CS20); //CTC 128
					};
				}
			else
				{
				OCR2 =  round(F_CPU / 64 / u8PWM);
				TCCR2 =  (1<<CS22); //CTC 64
				};
			}
		else				
			{
			OCR2 =  round(F_CPU / 32 / u8PWM);
			TCCR2 = (1<<CS21) | (1<<CS20); //CTC 32
			};
		}
	else	
		{	
		OCR2 =  round(F_CPU / 8 / u8PWM);
		TCCR2 = (1<<COM21); //CTC 8
		};			
	}
else
	{
	OCR2 =  round(F_CPU / u8PWM); // /1
	TCCR2 = (1<<CS20); //CTC 1
	}; 
};


// ***********************************
void T2_STOPPWM( void )
// ***********************************
{
TCCR2 = 0;
TCNT2 = 0;
INIT_OC2DIR();
SET_OC2_LOW();
};


// ***********************************
void T2_FastPWM( uint8_t u8SollPWM )  //30HZ fr Serrvos
// ***********************************
{
T2_STOPPWM();
if( u8SollPWM < 1 )  return;
//TCCR2 = COM21 WGM21  //FAST PWM CLEAR OC2
//OCRx =  Quarz / Vorteiler / gewnschte PWM 0..255
//SelectBestPreScaler_T2( u16Frq, u8SollPWM );//TCCR2 = COM21
OCR2 = u8SollPWM;
TCCR2 = (1<<CS22) | (1<<CS21) | (1<< CS20) | (1<< COM21) | (1<< WGM21) | (1<< WGM20); // Fast PWM; //CTC 1024 = 30 HZ
};


// ***********************************
void T2_FastFrqPWM(  uint16_t uFrq, uint8_t u8SollPWM )
// ***********************************
{
T2_STOPPWM();
if( u8SollPWM < 1 )  return;
//TCCR2 = COM21 WGM21  //FAST PWM CLEAR OC2
//OCRx =  Quarz / Vorteiler / gewnschte PWM 0..255
//SelectBestPreScaler_T2( u16Frq, u8SollPWM );//TCCR2 = COM21
OCR2 = u8SollPWM;
TCCR2 = (1<< COM21) | (1<< WGM21) | (1<< WGM20); // Fast PWM CTC
if( uFrq  == 31250 ) { TCCR2 |= T2_CS_1;  return;};
if( uFrq  == 3906 ) { TCCR2 |= T2_CS_8;  return;};
if( uFrq  == 977 ) { TCCR2 |= T2_CS_32;  return;};
if( uFrq  == 488 ) { TCCR2 |= T2_CS_64;  return;};
if( uFrq  == 246 ) { TCCR2 |= T2_CS_128;  return;};
if( uFrq  == 123 ) { TCCR2 |= T2_CS_256;  return;};
if( uFrq  == 31 ) { TCCR2 |= T2_CS_1024;  return;};
T2_STOPPWM(); // select war Unfug
};



//****************************************************************
#define ADC_5V_AN_C_USED_ENABLED  //SETZE 5V
uint16_t ADC_AT8_10Bit(uint8_t u8Chan) // 0..7
//****************************************************************
{ //REFERENCE = VCC
DDRC &=	~(1<< u8Chan);  //Bit loeschen
PORTC &= ~(1<< u8Chan); //Wegen Pullup abschalten
ADCSRA = (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1) | (1<< ADPS0);   //ADC EIN UND PreScaler
#ifdef ADC_EXTERN_5V_USED_ENABLED
ADMUX =  u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_5V_AN_C_USED_ENABLED
ADMUX =  (1<< REFS0) | u8Chan;	// VCC= REF. ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_INTERN_BANDGAP_USED_ENABLED
ADMUX = (1<< REFS1) | (1<< REFS0) | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
_delay_us(1);
ADCSRA |= (1<< ADSC);	//ADCSRA |= _BV(ADSC);	//Start conversion
while( ADCSRA & (1<< ADSC) )	//wait until _BV(ADSC)=0 =converstion completed
	{
	wdt_reset();
	};	
return ADC;	//ADCW; //get converted value
};


#ifdef UART_USE_ENABLED	
// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{
// zerlege UART RX Str inseine Delimitrer Bestandteile 
TokensRXStr( pcStrOrder ); //und lege diese in gsCmd.ucaCmd ab

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("STOPFRQ-P1") )  ) //B1
	{	
	T1_INITPIN_STOP_CTC();
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("STOPPWM-P2") )  ) //B3
	{	
	T2_STOPPWM();
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETFRQ-P1") )  )  //B1
	{	
	T1_CTC( (uint32_t)gsCmd.ixCmdVal_1 );
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETPWM-P2") )  )   // 30HZ  B3 Base Frequenz 0..255VLaue 0..255
	{	
	T2_FastPWM( (uint8_t)gsCmd.ixCmdVal_1 );
	return;
	};	


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETFRQPWM-P2") )  ) // Base Variabel Tabelle
	{	
	T2_FastFrqPWM( (uint16_t)gsCmd.ixCmdVal_1, (uint8_t)gsCmd.ixCmdVal_2 );
	return;
	};	


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETFRQ-P1") )  )  //B1
	{	
	T1_CTC( (uint32_t)gsCmd.ixCmdVal_1 );
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETPWM-P1") )  )  //B1 30 HZ
	{	
	T1_PWM( (uint16_t)gsCmd.ixCmdVal_1 );
	return;
	};	 

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETFRQPWM-P1") )  )  //B1 Tabelle
	{	
	T1_FRQPWM( (uint16_t)gsCmd.ixCmdVal_1, (uint16_t)gsCmd.ixCmdVal_2 );
	return;
	};	 
 
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("READFRQ_P3") )  )   // B1 Timebase
	{	
	READ_FRQ_Start();
	// Ab Hier EINE GanzeE SEKUNDE WARTEN, dann kommt automaisch Antwort
	// 	FRQ_MEASURE_READY_FLAG--> 
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP1") )  ) //B1
	{	
	if(TCCR1B) 
		{
		T1_INITPIN_STOP_CTC();
		READ_FRQ_Stop();
		};
	
	DDRB |= (1<< PB1);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTB |= (1<< PB1);
		}
	else
		{
		PORTB &= ~(1<< PB1);
		};
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP2") )  ) //B3
	{	
	if( TCCR2 )	T2_STOPPWM();
	DDRB |= (1<< PB3);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTB |= (1<< PB3);
		}
	else
		{
		PORTB &= ~(1<< PB3);
		};	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP3") )  ) //D5 = T1 INPUT
	{	
	if( TCCR1B ) {READ_FRQ_Stop();};
	DDRD |= (1<< PD5);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTD |= (1<< PD5);
		}
	else
		{
		PORTD &= ~(1<< PD5);
		};	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP4") )  ) //PC0
	{	
	DDRC |= (1<< PC0);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTC |= (1<< PC0);
		}
	else
		{
		PORTC &= ~(1<< PC0);
		};	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP5") )  ) //PC1
	{		
	DDRC |= (1<< PC1);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTC |= (1<< PC1);
		}
	else
		{
		PORTC &= ~(1<< PC1);
		};	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP6") )  ) //PC2
	{	
	DDRC |= (1<< PC2);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTC |= (1<< PC2);
		}
	else
		{
		PORTC &= ~(1<< PC2);
		};	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP7") )  ) //PC3
	{	
	DDRC |= (1<< PC3);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTC |= (1<< PC3);
		}
	else
		{
		PORTC &= ~(1<< PC3);
		};	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("OUTP8") )  ) //PC4
	{	
	DDRC |= (1<< PC4);
	if( gsCmd.ixCmdVal_1 )
		{
		PORTC |= (1<< PC4);
		}
	else
		{
		PORTC &= ~(1<< PC4);
		};	
	return;
	};
// ------------------------------------------
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP3") )  ) //PD5	
	{	
	if( TCCR1B ) 
		{
		READ_FRQ_Stop();
		};
	DDRD &= ~(1<<PD5);
	PORTD &= ~(1<<PD5);
	if( PIND & (1<<PD5) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP1") )  ) //PB1
	{
	T1_INITPIN_STOP_CTC();
	DDRB &= ~(1<<PB1);
	PORTB &= ~(1<<PB1);
	if( PINB & (1<<PB1) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP2") )  ) //PB3	
	{	
	if( TCCR2 ) {T2_STOPPWM();};
	DDRB &= ~(1<<PB3);
	PORTB &= ~(1<<PB3);
	if( PINB & (1<<PB3) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP3") )  ) //PD5
	{	
	if( TCCR1B ) 
		{
		READ_FRQ_Stop();
		};
	DDRD &= ~(1<<PD5);
	PORTD &= ~(1<<PD5);
	if( PIND & (1<<PD5) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP4") )  ) //PC0
	{	
	DDRC &= ~(1<<PC0);
	PORTC &= ~(1<<PC0);
	if( PINC & (1<<PC0) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP5") )  ) //PC1
	{	
	DDRC &= ~(1<<PC1);
	PORTC &= ~(1<<PC1);
	if( PINC & (1<<PC1) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP6") )  ) //PC2
	{	
	DDRC &= ~(1<<PC2);
	PORTC &= ~(1<<PC2);
	if( PINC & (1<<PC2) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP7") )  ) //PC3
	{	
	DDRC &= ~(1<<PC3);
	PORTC &= ~(1<<PC3);
	if( PINC & (1<<PC3) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("INP8") )  ) //PC4
	{	
	DDRC &= ~(1<<PC4);
	PORTC &= ~(1<<PC4);
	if( PINC & (1<<PC4) )
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};
		
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADCP4") )  )  
	{	
	PrintULongCR( ADC_AT8_10Bit( 0 ) ); //Nur 6 Eingnge
	return;
	};	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADCP5") )  )  
	{	
	PrintULongCR( ADC_AT8_10Bit( 1 ) ); //Nur 6 Eingnge
	return;
	};	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADCP6") )  )  
	{	
	PrintULongCR( ADC_AT8_10Bit( 2 ) ); //Nur 6 Eingnge
	return;
	};	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADCP7") )  )  
	{	
	PrintULongCR( ADC_AT8_10Bit( 3 ) ); //Nur 6 Eingnge
	return;
	};	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADCP8") )  )  
	{	
	PrintULongCR( ADC_AT8_10Bit( 4 ) ); //Nur 6 Eingnge
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADC") )  )  
	{	
	PrintULongCR( ADC_AT8_10Bit( (uint8_t)gsCmd.ixCmdVal_1 %  6 ) ); //Nur 6 Eingnge
	return;
	};	

// ---------------------------------
/*
// INPUTS
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("IN-BITPB") )  )   //Format SETBITPx,Bitrnr,[0,1]	
	{	
	DDRB &= ~(1<<gsCmd.ixCmdVal_1);
	PORTB &= ~(1<<gsCmd.ixCmdVal_1);
	if(PINB & (1<<gsCmd.ixCmdVal_1))
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

// INPUTS
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("IN-BITPC") )  )   //Format SETBITPx,Bitrnr,[0,1]	
	{	
	DDRC &= ~(1<<gsCmd.ixCmdVal_1);
	PORTC &= ~(1<<gsCmd.ixCmdVal_1);
	if(PINC & (1<<gsCmd.ixCmdVal_1))
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};

// INPUTS
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("IN-BITPD") )  )   //Format SETBITPx,Bitrnr,[0,1]	
	{	
	DDRD &= ~(1<<gsCmd.ixCmdVal_1);
	PORTD &= ~(1<<gsCmd.ixCmdVal_1);
	if(PIND & (1<<gsCmd.ixCmdVal_1))
		{
		uart_putc('1');
		}
	else
		{
		uart_putc('0');
		};
	PrintCR();
	return;
	};
	
// INPUT PORT	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("IN_PORTB") )  ) 
	{	
	DDRB = 0;
	PORTB = 0;
	PrintULongCR( PINB );
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("IN_PORTC") )  )
	{	
	DDRC = 0;
	PORTC = 0;
	PrintULongCR( PINC );
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("IN_PORTD") )  )
	{	
	DDRC &= 0x3;
	PORTC &= 0x3;
	PrintULongCR( PIND );
	return;
	};
	

// SET BITS	
	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETBITPB") )  )
	{	
	DDRB |= (1<<gsCmd.ixCmdVal_1);
	if( gsCmd.ixCmdVal_2 )
		{
		PORTB |= (1<<gsCmd.ixCmdVal_1);
		}
	else
		{
		PORTB &= ~(1<<gsCmd.ixCmdVal_1);
		};
	return;
	};


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETBITPC") )  )   //Format SETBITPx,Bitnr,[0,1]	
	{	
	DDRC |= (1<<gsCmd.ixCmdVal_1);
	if( gsCmd.ixCmdVal_2 )
		{
		PORTC |= (1<<gsCmd.ixCmdVal_1);
		}
	else
		{
		PORTC &= ~(1<<gsCmd.ixCmdVal_1);
		};
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETBITPD") )  )   //Format SETBITPx,Bitnr, [0,1]	
	{	
	DDRD |= (1<<gsCmd.ixCmdVal_1);
	if( gsCmd.ixCmdVal_2 )
		{
		PORTD |= (1<<gsCmd.ixCmdVal_1);
		}
	else
		{
		PORTD &= ~(1<<gsCmd.ixCmdVal_1);
		};
	return;
	};


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETPB") )  ) 
	{	
	DDRB = 0xFF;
	PORTB= (uint8_t)gsCmd.ixCmdVal_1;	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETPC") )  ) 
	{	
	DDRC = 0xFF;
	PORTC = (uint8_t)gsCmd.ixCmdVal_1;	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SETPD") )  ) 
	{	
	DDRD = 0xFF;
	PORTD= (uint8_t)gsCmd.ixCmdVal_1;	
	return;
	};
*/

// -----------------------------------------------------------
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PWM_T1A") )  ) 
	{	
	OCR1A = (uint16_t)gsCmd.ixCmdVal_1;	
	return;
	};
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PWM_T1B") )  ) 
	{	
	OCR1B = (uint16_t)gsCmd.ixCmdVal_1;	
	return;
	};

//  ---------------------------------------------------
	


// ------------------------------------

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GTCNT0") )  ) 
	{	
	PrintULongCR(TCNT0);
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GTCCR0") )  ) 
	{	
	PrintULongCR(TCCR0);
	return;
	};
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GTCNT1") )  ) 
	{	
	PrintULongCR(TCNT1);
	return;
	};
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GTCCR1A") )  ) 
	{	
	PrintULongCR(TCCR1A);
	return;
	};
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GTCCR1B") )  ) 
	{	
	PrintULongCR(TCCR1B);
	return;
	};
	
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GOCR1A") )  ) 
	{	
	PrintULongCR(OCR1A);
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GOCR1B") )  ) 
	{	
	PrintULongCR(OCR1B);
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GTCNT2") )  ) 
	{	
	PrintULongCR(TCNT2);
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("GOC2") )  ) 
	{	
	PrintULongCR(OCR2);
	return;
	};


// -------------------------------------------------------------------	
//  ---------------------------------------------------


gu8Status = TOGGLE_FLAG; // |STATUS_TRAFFIC_FLAG;
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("LEDON") )  )  
	{	
	gu8Status |= TOGGLE_FLAG;
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("LEDOFF") )  )  
	{	
	gu8Status &= ~TOGGLE_FLAG;
	TOGGLE_LED_OFF();
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("LED") )  )  
	{	
	if((uint8_t)gsCmd.ixCmdVal_1)
		{
		gu8Status |= TOGGLE_FLAG;
		}
	else
		{
		gu8Status &= ~TOGGLE_FLAG;
		TOGGLE_LED_OFF();
		};
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TALKON") )  )  
	{	
	gu8Status |= STATUS_TRAFFIC_FLAG;
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TALKOFF") )  )  
	{	
	gu8Status &= ~STATUS_TRAFFIC_FLAG;
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TALK") )  )  
	{	
	if((uint8_t)gsCmd.ixCmdVal_1)
		{
		gu8Status |= STATUS_TRAFFIC_FLAG;
		}
	else
		{
		gu8Status &= ~STATUS_TRAFFIC_FLAG;
		};
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )  
	{	
	Print_PStrCR( PSTR("Pong") );	
	return;
	};	

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("Device") )  )  
	{	
	Print_PStrCR( PSTR( AUTOR ) );	
	Print_PStrCR( PSTR( DATUM ) );	
	Print_PStrCR( PSTR(HARDWARE ) );	
	Print_PStrCR( PSTR( SHOW_BAUDRATE ) );	
	return;
	};

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("TT") ) )
	{
	PrintLongCR( gu32_Ticks );
	return;
	};


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("RR") ) )
	{
	gu32_Ticks = 0; //Reset TickCounter
	return;
	};


if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("BAUD") ) )
	{
	uart_init( UART_BAUD_SELECT((uint16_t)gsCmd.ixCmdVal_1, F_CPU) );
	ResetRxBuff();
	return;
	};	

};
#endif


// **********************************
int main(void)
// **********************************
{
uint32_t u32MCULast= 0;
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRB = 0;
DDRC = 0;
DDRD =  UART_RXTX_LEVEL; //TX
PORTD = UART_RXTX_PULL;

//ADCSR |= (1<<ADC); //ADC OFF

//INIT_OC2DIR();  //| (1<<OC1A) | (1<<OC1B)
//INIT_PWM_T1_DIR();

//SFIOR = (1<<PUD); //Pullup Disable

//Pointer and Strings init
wdt_enable(WDTO_1S); //WDTO_500MS 
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// Initialize UART library, pass baudrate and avr cpu clock
// with the macro UART_BAUD_SELECT()
//#ifdef UART_IS_USED
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );
ResetRxBuff();
sei();

Print_PStrCR( PSTR(HARDWARE) );
Print_PStrCR( PSTR(SOFTWARE) );

Print_PStrCR( PSTR(AUTOR) );
Print_PStrCR( PSTR(DATUM) );
uart_puts_p( PSTR("UART-Baud="));
Print_PStrCR( PSTR(SHOW_BAUDRATE) );
//#endif

OCR1A = PWM_T1_MITTE;
OCR1B = PWM_T1_MITTE;
OCR2 = OCR2_MITTE;

Start_TICK_T0();	//8 Bit Timer 2 = MS Tick Counter
gu32_Ticks = 0;
gu8Status = TOGGLE_FLAG; // |STATUS_TRAFFIC_FLAG;
// ************ MAIN LOOP FOR EVER *********************
  // TOGGLE
for (;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
	{
	sei();
 	wdt_reset(); //WATCHDOG!
	//Hier kann was gemacht werden jede 1 Sekunde	
	u32MCULast++;
	
	if( gu8Status & TICK_EVENT )
		{
		gu8Status &= ~TICK_EVENT;		
		
		if( gu8Status & TOGGLE_FLAG )
			{		
			INIT_TOGGLE();
			TOGGLE_LED();
			};
		
		if(gu8Status & FRQ_MEASURE_READY_FLAG)
			{
			PrintULongCR( (uint32_t)gufT1_MeasureFRQ );
			gu8Status &= ~FRQ_MEASURE_READY_FLAG;
			};
	
		//PrintLongCR( gu32_Ticks );
		if( gu8Status & STATUS_TRAFFIC_FLAG )
			{
			uart_puts_p( PSTR("MCU L/S=") );		
			PrintULongCR( u32MCULast );
			u32MCULast = 0;
			/*
			CRLF();
			ULongToNumStr( TCNT1 );
			CRLF();
			uart_puts_p( PSTR(", ") );		
			ULongToNumStr( gu32_Ticks );
			uart_puts( gcaNumStr );
			uart_puts_p( PSTR(", ") );		
			PrintLongCR( OCR1A );
			*/
			//PrintStrCR(  ByteToBin (TIMSK) );
			};
		}; // Tickcounter
				
	if( gu8Status & ORDER_EVENT)
		{
		CheckOrder( gcaRxStr );//gcaRxStr = accumulated str
		ResetRxBuff();
		};

	}; //main loop Ende
};
// ******************* MAIN END ********************************************
