	
#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

#define UART_BAUD_RATE 9600
//#define UART_BAUD_RATE 57600U
// #define UART_BAUD_RATE 19200U

#define TIMER_TICK_USED

#define DISABLE_ALL_PULLUP()	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL()	(SFIOR &= ~(_BV(PUD)));

#define WDTO_2S   7 //WatchDog

//========================================================================
//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
//Aufzaehlbezeichner
#define RX_BITNR	PORTD0 //0
#define TX_BITNR	PORTD1	//1
#define UART_RXTX_PULL	0x03
#define UART_RXTX_LEVEL	0x02

extern volatile  uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
extern void CheckOrder(char *PORTCStrOrder); //von gcaRxStr
#ifdef TIMER_TICK_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
#endif
 

#define OC1A_PIN	PORTB1
#define OC1B_PIN	PORTB2
#define OC2_PIN		PORTB3
#define ADC0_PIN	PORTC0
#define ADC1_PIN	PORTC1
#define ADC2_PIN	PORTC2
#define ADC3_PIN	PORTC3
#define ADC4_PIN	PORTC4
#define T1_PIN		PORTD5
#define AIN5_PIN	PORTD6
#define AIN1_PIN	PORTD7

#define T1_DDRX		DDRB
#define T1_PORT		PORTB
#define INIT_OC1A_PIN()		(T1_DDRX |= (1<< OC1A_PIN))
#define INIT_OC1B_PIN()		(T1_DDRX |= (1<< OC1B_PIN))
#define SET_T1_OC1A_PIN()	(T1_PORT |= (1<< OC1A_PIN) ) 
#define SET_T1_OC1B_PIN()	(T1_PORT &= ~(1<< OC1B_PIN))
#define CLR_T1_OC1A_PIN()	(T1_PORT &= ~(1<< OC1A_PIN))
#define CLR_T1_OC1B_PIN()	(T1_PORT &= ~(1<< OC1B_PIN))

#define OC2DDRX			DDRB
#define OC2PORT			PORTB
#define INIT_OC2DIR()	( OC2DDRX |= (1<<OC2_PIN) )
#define SET_OC2_HIGH()	( OC2PORT |= (1<<OC2_PIN) )
#define SET_OC2_LOW()	( OC2PORT &= ~(1<<OC2_PIN) )

#define T1_CS_1		(1<< CS10)
#define T1_CS_8		(1<< CS11)
#define T1_CS_64	((1<< CS11) | (1<< CS10))
#define T1_CS_256	(1<< CS12)
#define T1_CS_1024	((1<< CS12) | (1<< CS10))

//Overflow Frequenz T1 DATS PWM 1024
//FAST PWM 10 BIT 1024
#define T1_FRQ1		(F_CPU/1024.0)		///1 7812.5HZ
#define T1_FRQ8		(F_CPU/1024.0/8)	// 976.5625 Hz
#define T1_FRQ64	(F_CPU/1024.0/64)	// 122.0703125 Hz
#define T1_FRQ256	(F_CPU/1024.0/256)	// 30.051757813 Hz
#define T1_FRQ1024	(F_CPU/1024.0/2014)	// 7.629394531 Hz




#define T2_CS_1		(1<<CS20)
#define T2_CS_8		(1<<CS21)
#define T2_CS_32	((1<<CS21) | (1<< CS20))
#define T2_CS_64	(1<<CS22)
#define T2_CS_128	((1<<CS22) | (1<< CS20))
#define T2_CS_256	((1<<CS22) | (1<<CS21))
#define T2_CS_1024	((1<<CS22) | (1<<CS21) | (1<< CS20))

//Overflow Frequenz
#define T2_FRQ1		(F_CPU/256.0)		// / 1 31250 HZ
#define T2_FRQ8		(F_CPU/256.0/8) 	//3906.25 HZ
#define T2_FRQ32	(F_CPU/256.0/32) 	//976.5625 HZ
#define T2_FRQ64	(F_CPU/256.0/64) 	//488.28125 HZ
#define T2_FRQ128	(F_CPU/256.0/128)	//246.140625 HZ
#define T2_FRQ256	(F_CPU/256.0/256)	//123.0703125 HZ
#define T2_FRQ1024	(F_CPU/256.0/1024) 	//30.76757813 HZ

#define TICK_1000MS	3906 //31250	//122.0703125  8MHz
//#define TICK_1000MS	31250U	//122.0703125  8MHz
//#define TICKTIME_FLOAT	3906.25	//31250
//#define FRQ_FLOAT_FAKTOR	0.256 //( 1000.0 /  31250 ); 

//#define TICK_50MS		1562 // nur ~ungef	
#define TICK_25MS		98	//781 // nur ~ungef	
//#define TICK_25MS		781U // nur ~ungef	
 
#define PWM_T1_1MS		16000U
#define PWM_T1_MITTE	24000U
#define OCR2_MITTE	127
#define PWM_2MS		32000U

#define INIT_TOGGLE()	(DDRB |= (1<< PORTB2))  // TOGGLE
#define TOGGLE_LED()	(PORTB ^= (1<< PORTB2))
#define TOGGLE_LED_OFF()	(PORTB &= ~(1<< PORTB2))

#define TICK_EVENT				0x01
#define ORDER_EVENT				0x02
#define STATUS_TRAFFIC_FLAG		0x04
#define TOGGLE_FLAG				0x08
#define FRQ_MEASURE_ACTIVE_FLAG	0x20
#define FRQ_MEASURE_READY_FLAG	0x40
//volatile uint8_t gu8Status;
extern volatile uint8_t gu8Status;

#endif  //MAIN_HEADER
